//
// Copyright (C) 1999-2008 WideStudio/MWT Project Team
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#ifndef WSCIEFORM_H
#define WSCIEFORM_H

#include <WScom.h>
#include <WSCform.h>
class WSDcntrControl;

#define WSCieForm_VER  1000

class WSCieForm   :public WSCform{

  protected:
    WSDcntrControl*  _cntr;
    char*            _file_name;
    unsigned         _com_initialized:1;
    unsigned         _playing:1;
    void*            _disp_handle;
    void*            _cntl_handle;

    WSMFpropertyDef(WSNfileName,       char*,     _file_name ); 

    WSDLEX32 void _init();
    WSDLEX32 void _deinit();
  public:
    WSDLEX32 virtual void onResize(WSCrect*);
    WSDLEX32 virtual void onVisibleChange(WSCbool);
    WSDLEX32 virtual void onParentVisibleChange(WSCbool);

    WSDLEX32 WSCieForm(WSCbase* base, char* name);
    WSDLEX32 virtual ~WSCieForm();
    WSDLEX32 virtual long draw();

    WSMFguiClassDef(WSCieForm,WSCform);
    WSMFversionDef(WSCieForm);
};

#endif //WSCIEFORM_H
