#include <WScom.h>
#include <WSCfunctionList.h>
#include <WSCbase.h>

#include <WSCmessageDialog.h>
#include "newwin000.h"

//----------------------------------------------------------
//Function for the event procedure
//----------------------------------------------------------
void button1(WSCbase* object){
	long col, row;

	col = newshee_000->getFocusCol();
	row = newshee_000->getFocusRow();

	char type = newshee_000->getCellType(col, row);

	WSCstring msg;
	msg = "";
	msg << "col:";
	msg << col;
	msg << ",row:";
	msg << row;
	msg << "\ntype:";

	if(type == WSCSHEET_CELL_TYPE_TEXT) {
		msg << "TEXT\n";
		msg << "text:";
		msg << newshee_000->getText(col, row);
	} else if(type == WSCSHEET_CELL_TYPE_BUTTON) {
		msg << "BUTTON\n";
		msg << "text:";
		msg << newshee_000->getText(col, row);
	} else if(type == WSCSHEET_CELL_TYPE_RADIO) {
		msg << "RADIO\n";
		msg << "text:";
		msg << newshee_000->getText(col, row);
	} else if(type == WSCSHEET_CELL_TYPE_COMBOBOX) {
		msg << "COMBOBOX\n";
		msg << "text:";
		msg << newshee_000->getText(col, row);
		msg << "\nListIndex:";
		msg << newshee_000->getCellListIndex(col, row);
    } else if(type == WSCSHEET_CELL_TYPE_DROPDOWNLIST) {
		msg << "DROPDOWNLIST\n";
		msg << "text:";
		msg << newshee_000->getText(col, row);
		msg << "\nListIndex:";
		msg << newshee_000->getCellListIndex(col, row);
	}
	WSCmessageDialog* msgDlg = WSGIappMessageDialog();
	msgDlg->setProperty(WSNlabelString, msg);
	msgDlg->popup();
}
static WSCfunctionRegister  op("button1",(void*)button1);
