#include <WScom.h>
#include <WSCcolorSet.h>
#include <WSCmessageDialog.h>
#include "newwin000.h"

void init()
{
	// Button
	ss->setStartCol(2);
	ss->setStartRow(-1);
	ss->setEndCol(2);
	ss->setEndRow(ss->getRowCount());

	ss->setSelectCell(True);
	ss->setCellType(WSCSHEET_CELL_TYPE_BUTTON);
	ss->setCellItems("button");
	ss->setSelectCell(False);

	// radio
	ss->setStartCol(3);
	ss->setStartRow(-1);
	ss->setEndCol(3);
	ss->setEndRow(ss->getRowCount());

	ss->setSelectCell(True);
	ss->setCellType(WSCSHEET_CELL_TYPE_RADIO);
	ss->setCellItems("checkbox");
	ss->setCellCheck(True);
	ss->setCheckColor("#ff0000");
	ss->setSelectCell(False);
	
	// combobox
	ss->setStartCol(4);
	ss->setStartRow(-1);
	ss->setEndCol(4);
	ss->setEndRow(ss->getRowCount());

	ss->setSelectCell(True);
	ss->setCellType(WSCSHEET_CELL_TYPE_COMBOBOX);
	ss->setText("combobox");
	ss->setCellItems("aaaaa,bbbbb,ccccc");
	ss->setSelectCell(False);

	// dropdownlist
	ss->setStartCol(5);
	ss->setStartRow(-1);
	ss->setEndCol(5);
	ss->setEndRow(ss->getRowCount());

	ss->setSelectCell(True);
	ss->setCellType(WSCSHEET_CELL_TYPE_DROPDOWNLIST);
	ss->setText("22222");
	ss->setCellItems("11111,22222,33333");
	ss->setSelectCell(False);
}

void setEditEnabled(short val)
{
	ss->setEditEnabled(val);
}
void textSet()
{
	long col1, col2, row1, row2;
	WSCstring str;
	
	str = newvifi_000->getProperty(WSNlabelString);

	long set = newvrad_026->getProperty(WSNstatus);
	
	long t = newradi_024->getProperty(WSNvalue);

	long b = newvrad_025->getProperty(WSNstatus);

	if(set) {
		if(b == 0) {
			col1 = newvifi_006->getProperty(WSNlabelString);
			row1 = newvifi_008->getProperty(WSNlabelString);
			if(t == 1) {
				ss->setFixedText(col1, row1, str);
			} else {
				ss->setCol(col1);
				ss->setRow(row1);
				ss->setText(str);
			}
		} else {
			if(t == 1) {
				WSCstring s;
				s = "Please make \"multiple\" off for fixed cell..";
				WSGIappMessageDialog()->setProperty(WSNlabelString, s);
				WSGIappMessageDialog()->popup();
			} else {
				col1 = newvifi_011->getProperty(WSNlabelString);
				col2 = newvifi_013->getProperty(WSNlabelString);
				row1 = newvifi_015->getProperty(WSNlabelString);
				row2 = newvifi_017->getProperty(WSNlabelString);
				
				if(!ss->getSelectCell()) {
					ss->setStartCol(col1);
					ss->setStartRow(row1);

					ss->setEndCol(col2);
					ss->setEndRow(row2);

					ss->setSelectCell(True);
				}
				ss->setText(str);
				
				ss->setSelectCell(False);
			}
		}
	} else {
		if(b == 0) {
			if(t != 1) {
				col1 = newvifi_006->getProperty(WSNlabelString);
				row1 = newvifi_008->getProperty(WSNlabelString);
				if(t == 1) {
					newvifi_000->setProperty(WSNlabelString, ss->getFixedText(col1, row1));
				} else {
					newvifi_000->setProperty(WSNlabelString, ss->getText(col1, row1));
				}
			}
		} else {
			col1 = newvifi_011->getProperty(WSNlabelString);
			row1 = newvifi_015->getProperty(WSNlabelString);
			newvifi_000->setProperty(WSNlabelString, ss->getText(col1, row1));
		}
	}
}
void foreColor()
{
	long col1, col2, row1, row2;
	WSCstring str;
	short color;
	
	str = newvifi_022->getProperty(WSNlabelString);

	if(*(str.getString()) == '#') {
		color = WSGIappColorSet()->getColorNo(str);
	} else {
		color = atoi(str.getString());
	}
	long set = newvrad_026->getProperty(WSNstatus);
	
	long t = newradi_024->getProperty(WSNvalue);

	long b = newvrad_025->getProperty(WSNstatus);

	if(set) {
		if(b == 0) {
			col1 = newvifi_006->getProperty(WSNlabelString);
			row1 = newvifi_008->getProperty(WSNlabelString);
			if(t == 1) {
				ss->setFixedTextColor(color);
			} else {
				ss->setCol(col1);
				ss->setRow(row1);
				ss->setCellTextColor(color);
			}
		} else {
			if(t == 1) {
				WSCstring s;
				s = "Please make \"multiple\" off for fixed cell..";
				WSGIappMessageDialog()->setProperty(WSNlabelString, s);
				WSGIappMessageDialog()->popup();
			} else {
				col1 = newvifi_011->getProperty(WSNlabelString);
				col2 = newvifi_013->getProperty(WSNlabelString);
				row1 = newvifi_015->getProperty(WSNlabelString);
				row2 = newvifi_017->getProperty(WSNlabelString);
				
				if(!ss->getSelectCell()) {
					ss->setStartCol(col1);
					ss->setStartRow(row1);

					ss->setEndCol(col2);
					ss->setEndRow(row2);

					ss->setSelectCell(True);
				}
				ss->setCellTextColor(color);
				
				ss->setSelectCell(False);
			}
		}
	} else {
		if(b == 0) {
			if(t != 1) {
				col1 = newvifi_006->getProperty(WSNlabelString);
				row1 = newvifi_008->getProperty(WSNlabelString);
				if(t == 1) {
					newvifi_022->setProperty(WSNlabelString, ss->getFixedTextColor());
				} else {
					newvifi_022->setProperty(WSNlabelString, ss->getCellTextColor(col1, row1));
				}
			}
		} else {
			col1 = newvifi_011->getProperty(WSNlabelString);
			row1 = newvifi_015->getProperty(WSNlabelString);
			newvifi_022->setProperty(WSNlabelString, ss->getCellTextColor(col1, row1));
		}
	}
}
void bkColor()
{
	long col1, col2, row1, row2;
	WSCstring str;
	short color;
	
	str = newvifi_019->getProperty(WSNlabelString);

	if(*(str.getString()) == '#') {
		color = WSGIappColorSet()->getColorNo(str);
	} else {
		color = atoi(str.getString());
	}
	long set = newvrad_026->getProperty(WSNstatus);
	
	long t = newradi_024->getProperty(WSNvalue);

	long b = newvrad_025->getProperty(WSNstatus);

	if(set) {
		if(b == 0) {
			col1 = newvifi_006->getProperty(WSNlabelString);
			row1 = newvifi_008->getProperty(WSNlabelString);
			if(t == 1) {
				ss->setFixedBkColor(color);
			} else {
				ss->setCol(col1);
				ss->setRow(row1);
				ss->setCellBkColor(color);
			}
		} else {
			if(t == 1) {
				WSCstring s;
				s = "Please make \"multiple\" off for fixed cell..";
				WSGIappMessageDialog()->setProperty(WSNlabelString, s);
				WSGIappMessageDialog()->popup();
			} else {
				col1 = newvifi_011->getProperty(WSNlabelString);
				col2 = newvifi_013->getProperty(WSNlabelString);
				row1 = newvifi_015->getProperty(WSNlabelString);
				row2 = newvifi_017->getProperty(WSNlabelString);
				
				if(!ss->getSelectCell()) {
					ss->setStartCol(col1);
					ss->setStartRow(row1);

					ss->setEndCol(col2);
					ss->setEndRow(row2);

					ss->setSelectCell(True);
				}
				ss->setCellBkColor(color);
				
				ss->setSelectCell(False);
			}
		}
	} else {
		if(b == 0) {
			if(t != 1) {
				col1 = newvifi_006->getProperty(WSNlabelString);
				row1 = newvifi_008->getProperty(WSNlabelString);
				if(t == 1) {
					newvifi_019->setProperty(WSNlabelString, ss->getFixedBkColor());
				} else {
					newvifi_019->setProperty(WSNlabelString, ss->getCellBkColor(col1, row1));
				}
			}
		} else {
			col1 = newvifi_011->getProperty(WSNlabelString);
			row1 = newvifi_015->getProperty(WSNlabelString);
			newvifi_019->setProperty(WSNlabelString, ss->getCellBkColor(col1, row1));
		}
	}
}
void numberChange()
{
	ss->setVertAutoNumber(newvrad_027->getProperty(WSNstatus));
	ss->setHorzAutoNumber(newvrad_027->getProperty(WSNstatus));
	ss->draw();
}
void cell_add()
{
	if((short)newvrad_003->getProperty(WSNstatus)) {
		ss->setNoRefresh(True);
		ss->insertRow();
		long rows = ss->getStartRow();
		long rowe = ss->getEndRow();
		// Button
		ss->setStartCol(2);
		ss->setEndCol(2);
		ss->setStartRow(rows);
		ss->setEndRow(rowe);

		ss->setSelectCell(True);
		ss->setCellType(WSCSHEET_CELL_TYPE_BUTTON);
		ss->setCellItems("button");
		ss->setSelectCell(False);

		// radio
		ss->setStartCol(3);
		ss->setEndCol(3);
		ss->setStartRow(rows);
		ss->setEndRow(rowe);

		ss->setSelectCell(True);
		ss->setCellType(WSCSHEET_CELL_TYPE_RADIO);
		ss->setCellItems("checkbox");
		ss->setCellCheck(True);
		ss->setCheckColor("#ff0000");
		ss->setSelectCell(False);
		
		// combobox
		ss->setStartCol(4);
		ss->setEndCol(4);
		ss->setStartRow(rows);
		ss->setEndRow(rowe);

		ss->setSelectCell(True);
		ss->setCellType(WSCSHEET_CELL_TYPE_COMBOBOX);
		ss->setText("combobox");
		ss->setCellItems("aaaaa,bbbbb,ccccc");
		ss->setSelectCell(False);

		// dropdownlist
		ss->setStartCol(5);
		ss->setEndCol(5);
		ss->setStartRow(rows);
		ss->setEndRow(rowe);

		ss->setSelectCell(True);
		ss->setCellType(WSCSHEET_CELL_TYPE_DROPDOWNLIST);
		ss->setText("22222");
		ss->setCellItems("11111,22222,33333");
		ss->setSelectCell(False);

		ss->setNoRefresh(False);
		ss->draw();
	} else {
		ss->insertCol();
	}
}
void cell_del()
{
	if((short)newvrad_003->getProperty(WSNstatus)) {
		ss->deleteRow();
	} else {
		ss->deleteCol();
	}
}
