#ifndef _WSCNTRCONTROL_H_

#include "ipserver.h"
#include "ctrlobj.h"
//#include "olectl.h"
#include "iwscntr.h"
//#include "Dispids.H"

class WSDcntrControl :public COleControl,public IWScntr,public ISupportErrorInfo{
    void* _handle;
  public:
    DECLARE_STANDARD_UNKNOWN();
    DECLARE_STANDARD_DISPATCH();
    DECLARE_STANDARD_SUPPORTERRORINFO();

    WSDLEX32 WSDcntrControl(IUnknown *pUnkOuter);
    WSDLEX32 virtual ~WSDcntrControl();

    static IUnknown *Create(IUnknown *);
    virtual BOOL    AfterCreateWindow(void);
    virtual void    BeforeDestroyWindow(void);
    virtual void    AfterDestroyWindow(void);

    STDMETHOD(SetHandle)(void *pValue);

#if 0
    STDMETHOD(GetUserType)(DWORD,WCHAR*);
    STDMETHOD(GetExtent)(DWORD,LONG,DVTARGETDEVICE*,tagSIZE*);
#endif

  private:

    STDMETHOD(LoadBinaryState)(IStream *pStream);
    STDMETHOD(SaveBinaryState)(IStream *pStream);
    STDMETHOD(LoadTextState)(IPropertyBag *pPropertyBag, IErrorLog *pErrorLog);
    STDMETHOD(SaveTextState)(IPropertyBag *pPropertyBag, BOOL fWriteDefault);
    STDMETHOD(OnDraw)(DWORD dvaspect, HDC hdcDraw, LPCRECTL prcBounds, LPCRECTL prcWBounds, HDC hicTargetDev, BOOL fOptimize);


    virtual LRESULT WindowProc( UINT msg, WPARAM wParam, LPARAM lParam);
    virtual BOOL    RegisterClassData(void);

    virtual HRESULT InternalQueryInterface(REFIID, void **);
};

extern const GUID    *rgWScntrPropPages [];
DEFINE_WINDOWLESSCONTROLOBJECT(WScntr,
    &CLSID_WScntr,
    "ActiveXWScntrControl",
    WSDcntrControl::Create,
    1,
    &IID_IWScntr,
    "WSCNTR.HLP",
    &DIID_DWScntrEvents,
    OLEMISC_SETCLIENTSITEFIRST|OLEMISC_ACTIVATEWHENVISIBLE|
OLEMISC_RECOMPOSEONRESIZE|OLEMISC_CANTLINKINSIDE|OLEMISC_INSIDEOUT,
	FALSE,
	FALSE,
    RESID_TOOLBOX_BITMAP,
    "WSCNTRWndClass",
    1,
    rgWScntrPropPages,
    0,
    NULL);

#define OBJECT_TYPE_CTLWSCNTR 0
#define OBJECT_TYPE_PPGWSCNTRGENERAL 1

WSDLEX32 HRESULT ComCoInitialize(void*);
WSDLEX32 OLECHAR* ComGetOleChar(char* str);
WSDLEX32 HRESULT ComGetProperty(IDispatch* disp_ptr, OLECHAR* wszName, VARIANT* ret);
WSDLEX32 HRESULT ComPutProperty(IDispatch* disp_ptr, OLECHAR* pwszName, const VARIANT* pvValue);
WSDLEX32 HRESULT ComInvoke(IDispatch* disp_ptr, OLECHAR* wszMethod, VARIANT* ret, int nArgs, ...);

#define _WSCNTRCONTROL_H_
#endif // _WSCNTRCONTROL_H_


